#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "typedefs.h"
#include "support.h"
#include "sound.h"
#include "usart.h"

const char MSG_VERSION[] = "Megalol der Sprechende uC\r\n";
volatile unsigned int bytecounter = 0;
PGM_P test = sound;

//############################################################################
//Timer1 Interrupt
ISR (TIMER1_OVF_vect)
//############################################################################
{
	bytecounter++;
	OCR0 = pgm_read_byte(test++);
	TCNT1 = 65535 - (SYSCLK/64/8000);
	
	if(bytecounter>soundbytes)
	{
		bytecounter = 0;
		test = sound;
	}
}


//############################################################################
//Hauptprogramm
int main (void) 
//############################################################################
{
	usart_init(); // Serielle Schnittstelle initialisieren
	usart_writeln_flash_str(MSG_VERSION); 
	
	//Set TIMER0 (PWM OC0 Pin)
	DDRB |= (1<<3);
	TCCR0 |= (1<<WGM01|1<<WGM00|1<<COM01|1<<CS00);
	OCR0 = 128;
	
	//Set TIMER1 
	TIMSK |= (1 << TOIE1);
	//Prescaler 64
	TCCR1B = (1<<CS10 | 1<<CS11);
	//SYSCLK define in usart.h
	TCNT1 = 65535 - (SYSCLK/64/8000);
	
	//Globale Interrupts Enable
	sei();
	
	while(1)
	{ 
	}
}

